local FC = ...
FC:registerEnumValue ("BUILDING_PART_TYPE", "RESOURCE_NODE")
local backButton = {}
backButton.ShortName = "FE_BACK_ACCEPT" 
backButton.EventActionList = {}
backButton.EventActionList[1] = {}
backButton.EventActionList[1].DataType = "EVENT_ACTION_IGNORE"
backButton.EventActionList[1].OnClickCallback = {}
backButton.EventActionList[1].OnClickCallback.DataType = "EVENT_CALLBACK_TRIGGER_EVENT" 
backButton.EventActionList[1].OnClickCallback.Event = "INFINITE_RESOURCES_EVENT" 

local exitButton = {}
exitButton.ShortName = "FE_EXIT_ACCEPT"
	

local comList = {"BEER","BERRIES","BREAD","BOAR","CHEESE","CLOTHES","FISH","GOLD_COINS","HERBS","HONEY","MEAL","SPEAR","SWORD","WINE"}
local conList = {"GLASS","GOLD_BARS","MARBLE","PLANK","POLISHED_STONE","STONE","TOOL","WOOD","WOOLEN_CLOTH"}
local rawList = {"BARREL","COAL","FLOUR", "GEMS", "GOLD_ORE","GRAPES","HOP","IRON","IRON_ORE","LEATHER", "MILK","QUARTZ","WHEAT","WOOL"}
local weatherList = {"WEATHER_RAINY","WEATHER_SUNNY"}
local influenceList = {"LABOUR","KINGDOM","CLERGY"}
local blueprintlist = {"BLUEPRINT_ROMAN_CHURCH","LEGACY_CHURCH_BLUEPRINT"}
local campaignList = {"MILITARY_CAMPAIGN_AVERAGE","MILITARY_CAMPAIGN_EASY","MILITARY_CAMPAIGN_HARD"}
local unlockList = {"UNLOCKABLE_CLERGY_MONASTERY_APIARY","UNLOCKABLE_CLERGY_MONASTERY_HERB_GARDEN","UNLOCKABLE_CLERGY_MONASTERY_WINE_PRODUCTION","UNLOCKABLE_CLERGY_RUSTIC_CHURCH_ADDITIONAL_PARTS","UNLOCKABLE_KINGDOM_WOODEN_KEEP_DECORATIVE","UNLOCKABLE_LABOUR_LORD_MANOR_STONE_SET","UNLOCKABLE_LABOUR_TAVERN_STONE_SET","UNLOCKABLE_LABOUR_LORD_MANOR_BAILIFF_OFFICE","UNLOCKABLE_LABOUR_LORD_MANOR_TAX_OFFICE"}
local percList = {0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2,5,10}
local intList = {1,2,3,4,5,10,20,30,50,75,100}
local resourcePanelList = {
	"COMMODITY_RESOURCES",
	"RAW_RESOURCES",
	"CONSTRUCTION_RESOURCES"
}
local tradePanelList = {
	"TRADE_ROUTE_ADD",
	"TRADE_ROUTE_REMOVE"
}
local jobList = {
	"BAILIFF",
	"BAKER",
--	"BARTENDER",
	"BEE_KEEPER",
	"BLACKSMITH",
	"BREWER",
--	"BUILDER",
	"CARPENTER",
	"CHEESE_MAKER",
	"COAL_BURNER",
	"COOK",
	"COOPER",
	"DAIRY_FARMER",
	"FARMER",
	"FISHERMAN",
--	"FORESTER",
	"GATHERER",
	"HERBALIST",
	"HUNTER",
	"IRON_SMELTER",
--	"MARKET_TENDER",
	"MILLER",
	"MINER",
--	"SCHOLAR",
	"SHEPHERD",
--	"SOLDIER",
	"STONEMASON",
	"TAILOR",
--	"TAX_COLLECTOR",
--	"TRANSPORTER",
	"WEAVER",
	"WOOD_CUTTER"
}
local needList = {
	"NEED_FOOD",
	"NEED_GOODS",
	"NEED_HOUSE_LEVEL_1",
	"NEED_HOUSE_LEVEL_2",
	"NEED_HOUSE_MONASTERY",
	"NEED_HOUSE_SOLDIER",
	"NEED_LUXURY",
	"NEED_PRIMARY_NEED",
	"NEED_SERVICE",
}
local gameRulePanelList = {
	"TRADE_BONUS",
	"MARKET_PRICE",
	"PRODUCTIVITY",
	"YIELD",
--	"HAPPINESS_DEBUFF",
	"HAPPINESS_BONUS",
	"NEED_DEPLETION_RATE",
--	"NEED_FILLED",
	"IMMIGRATION_RATE",
	"SOLDIER_RECOVERY",
	"TRAINING",
	"LEARNING",
	"PASSIVE_INFLUENCE",
	"SPLENDOR",
--	"DESIRABILITY",
	"MAINTENANCE"
}
local mainPanelList = {

	"RESOURCES_MAIN",
	"WEATHER",
	"INFLUENCE",
	"BLUEPRINT",

	"GAME_RULES",
	"TRADE_ROUTE"
--	{{7}, "UNLOCK_BUILDING"},

--	{{8}, "MILITARY_CAMPAIGN"},
}

local function QuestRewardResources(resources)
	return {
		DataType = "QUEST_REWARD_RESOURCES",
		ResourceCollection = resources
	}
end

local function QuestRewardUnlock(unlockable)
	return {
		DataType = "QUEST_REWARD_UNLOCK_BUILDING_LIST",
		UnlockName = unlockable
	}
end

local function QuestRewardHappy(percent, duration)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_HAPPINESS",
			Name = "GAME_RULE_MODIFIER_HAPPINESS_NAME",
			IsUntilRemoval = false,
			BonusHappinessPercentage = percent,
			DurationInDays = duration
		}
	}
end

local function QuestRewardNeedRate(percent, duration, need)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
			Name = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE_NAME",
			IsUntilRemoval = false,
			BonusInPerc = percent,
			DurationInDays = duration,
			NeedType = need
		}
	}
end

local function QuestRewardJob(percent, duration)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_JOB_LEARNING_SPEED",
			Name = "GAME_RULE_MODIFIER_JOB_LEARNING_SPEED_NAME",
			IsUntilRemoval = false,
			XPBonusPercentage = percent,
			DurationInDays = duration
		}
	}
end

local function QuestRewardMilitary(percent, duration)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_MILITARY_TRAINING",
			Name = "GAME_RULE_MODIFIER_MILITARY_TRAINING_NAME",
			IsUntilRemoval = false,
			XPBonusPercentage = percent,
			DurationInDays = duration
		}
	}
end

local function QuestRewardCrop(percent, duration,list)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
			Name = "GAME_RULE_MODIFIER_CROP_YIELDS_NAME",
			IsUntilRemoval = false,
			YieldPercentage = percent,
			DurationInDays = duration,
			ResourceList = list
		}
	}
end

local function QuestRewardImmigrationRate(amount, duration)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_IMMIGRATION_RATE",
			Name = "GAME_RULE_MODIFIER_IMMIGRATION_RATE__NAME",
			IsUntilRemoval = false,
			QuantityToAdd = amount,
			DurationInDays = duration
		}
	}
end

local function QuestRewardNeedFilled(resource,duration)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_NEED_PERMANENTLY_FILLED",
			Name = "GAME_RULE_MODIFIER_NEED_PERMANENTLY_FILLED_NAME",
			IsUntilRemoval = false,
			NeedResource = resource,
			DurationInDays = duration
		}
	}
end

local function QuestRewardTradeBonus(percent, duration, estate)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_TRADE_BONUS",
			Name = "GAME_RULE_MODIFIER_TRADE_BONUS_NAME",
			IsUntilRemoval = false,
			BonusRevenuePercentage = percent,
			DurationInDays = duration,
			EstateAllegianceList = estate
		}
	}
end

local function QuestRewardSplendor(percent, duration)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_MONUMENT_SPLENDOR",
			Name = "GAME_RULE_MODIFIER_MONUMENT_SPLENDOR_NAME",
			IsUntilRemoval = false,
			SplendorMultiplier = percent,
			DurationInDays = duration
		}
	}
end

local function QuestRewardDesirability(percent, duration)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_IMPROVE_AREA_DESIRABILITY",
			Name = "GAME_RULE_MODIFIER_IMPROVE_AREA_DESIRABILITY_NAME",
			IsUntilRemoval = false,
			AssetDesirabilityModifier = percent,
			AssetDesirability = "",
			DurationInDays = duration
		}
	}
end

local function QuestRewardMaintenance(percent, duration)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_BUILDING_MAINTENANCE_COST",
			Name = "GAME_RULE_MODIFIER_BUILDING_MAINTENANCE_COST_NAME",
			IsUntilRemoval = false,
			Multiplier = percent,
			DurationInDays = duration
		}
	}
end

local function QuestRewardProduction(percent, duration, job)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_JOB_STATUS",
			Name = "GAME_RULE_MODIFIER_JOB_STATUS_NAME",
			IsUntilRemoval = false,
			ProductivityChangePerc = percent,
			DurationInDays = duration,
			AssetJob = job
		}
	}
end

local function QuestRewardPassiveInfluence(percent, duration, estate)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_ESTATE_INFLUENCE",
			Name = "GAME_RULE_MODIFIER_ESTATE_INFLUENCE_NAME",
			IsUntilRemoval = false,
			InfluenceGainPerWeek = percent,
			DurationInDays = duration,
			Estate = estate
		}
	}
end

local function QuestRewardRecovery(percent, duration)
	return {
		DataType = "QUEST_REWARD_GAME_RULE",
		RuleModifier = {
			DataType = "GAME_RULE_MODIFIER_SOLDIER_RECOVERY_SPEED",
			Name = "GAME_RULE_MODIFIER_SOLDIER_RECOVERY_SPEED_NAME",
			IsUntilRemoval = false,
			Bonus = percent,
			DurationInDays = duration
		}
	}
end

local function QuestFunctionDelivery(resources)
	return {
		DataType = "QUEST_FUNCTION_DELIVER_RESOURCES",
		ResourceListToDeliver = resources,
		Estate = "CLERGY",
		DaysCount = 10000000
	}
end

local function QuestFunctionBuild(BuildingList)
	return {
		DataType = "QUEST_FUNCTION_BUILD",
		BuildingListToBuild = BuildingList
	}
end

local function QuestRewardInfluence(influence)
	return {
		DataType = "QUEST_REWARD_INFLUENCE",
		EstateInfluence = influence
	}
end

local function QuestRewardBlueprint(blueprintAsset)
	return {
		DataType = "QUEST_REWARD_BLUEPRINT",
		StubBlueprint = blueprintAsset
	}
end

local function QuestRewardImmigration()
	return {
		DataType = "QUEST_REWARD_IMMIGRATION_WAVE"
	}
end

local function QuestRewardTerritory()
	return {
		DataType = "QUEST_REWARD_TERRITORY",
		Amount = 1
	}
end

local function QuestRewardMarket(perc,duration)
	return {
		DataType = "QUEST_REWARD_MARKET_PRICES",
		PriceBonuses = perc,
		DurationInDays = duration
	}
end

function table.shallow_copy(t)
  local t2 = {}
  for k,v in pairs(t) do
    t2[k] = v
  end
  return t2
end

function tableSize(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function switch(n, ...)
  for _,v in ipairs {...} do
    if v[1] == n or v[1] == nil then
      return v[2]()
    end
  end
end

function case(n,f)
  return {n,f}
end

function default(f)
  return {nil,f}
end

local function overrideEntry(path, T)
	local p = path
	return switch( tableSize(p),
		case( 1, function() choiceList[p[1]] = T end),
		case( 2, function() choiceList[p[1]].EventActionList[p[2]] = T end),
		case( 3, function() choiceList[p[1]].EventActionList[p[2]].ChoiceList[p[3]] = T end),
		case( 5, function() choiceList[p[1]].EventActionList[p[2]].ChoiceList[p[3]].EventActionList[p[4]].ChoiceList[p[5]] = T end),
		case( 7, function() choiceList[p[1]].EventActionList[p[2]].ChoiceList[p[3]].EventActionList[p[4]].ChoiceList[p[5]].EventActionList[p[6]].ChoiceList[p[7]] = T end),
		case( 9, function() choiceList[p[1]].EventActionList[p[2]].ChoiceList[p[3]].EventActionList[p[4]].ChoiceList[p[5]].EventActionList[p[6]].ChoiceList[p[7]].EventActionList[p[8]].ChoiceList[p[9]] = T end)
	)
end

local function insertEntry(path, T)
	local p = path
	return switch( tableSize(p),
		case( 1, function() table.insert(choiceList,T) end),
		case( 2, function() table.insert(choiceList[p[1]].EventActionList, T) end),
		case( 3, function() table.insert(choiceList[p[1]].EventActionList[p[2]].ChoiceList, T) end),
		case( 5, function() table.insert(choiceList[p[1]].EventActionList[p[2]].ChoiceList[p[3]].EventActionList[p[4]].ChoiceList, T) end),
		case( 7, function() table.insert(choiceList[p[1]].EventActionList[p[2]].ChoiceList[p[3]].EventActionList[p[4]].ChoiceList[p[5]].EventActionList[p[6]].ChoiceList, T) end),
		case( 9, function() table.insert(choiceList[p[1]].EventActionList[p[2]].ChoiceList[p[3]].EventActionList[p[4]].ChoiceList[p[5]].EventActionList[p[6]].ChoiceList[p[7]].EventActionList[p[8]].ChoiceList, T) end)
)
end

local function createPanelButtons(p,list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_".. v .."_ACCEPT" 
		t.EventActionList = {}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "ACTION_SHOW_NARRATIVE_PANEL"
		t.EventActionList[1].ChoiceList = {}
		t.EventActionList[1].NarrativePanelData = {}
		t.EventActionList[1].NarrativePanelData.Title = "FE_".. v.."_EVENT_TITLE" 
		t.EventActionList[1].NarrativePanelData.Description = "FE_".. v.."_EVENT_DESC" 
		t.EventActionList[1].NarrativePanelData.PanelVisual = "ILLUSTRATION_ESTATE_CHURCH"
		insertEntry(p,t)
	end
end

local function createResourceButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = v
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardResources({{Resource = v, Quantity = 1000}})
		}
		insertEntry(p,t)
	end
end

local function createWeatherButtons(p,list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = v
		t.EventActionList = {}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "EVENT_ACTION_CHANGE_WEATHER"
		t.EventActionList[1].AssetWeather = v
		t.EventActionList[1].IsWeatherSystemOverriden = false
		insertEntry(p,t)
	end
end

local function createInfluenceButtons(p,list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = v
		t.EventActionList = {}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardInfluence({Estate = v, Quantity = 20})
		}
		insertEntry(p,t)
	end
end

local function createBlueprintButtons(p,list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = v
		t.EventActionList = {}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardBlueprint(v)
		}
		insertEntry(p,t)
	end
end

local function createUnlockBuildingButtons(p,list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardUnlock(v)
		}
		insertEntry(p,t)
	end
end

local function createMilitaryCampaignButtons(p,list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "EVENT_ACTION_IGNORE"
		t.EventActionList[1].OnClickCallback = {}
		t.EventActionList[1].OnClickCallback.DataType = "EVENT_CALLBACK_TRIGGER_EVENT" 
		t.EventActionList[1].OnClickCallback.Event = v 
		insertEntry(p,t)
	end
end

local function createTradeRouteButtons (p,op)
	local i = 1
	for _,v in pairs(FCconfig["profile"]["tradingVillages"]) do
		local t = {}
		t.ShortName = v["name"]
		t.EventActionList={}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "EVENT_ACTION_"..op.."_TRADE_ROUTE"
		t.EventActionList[1].VillageListToAdd = {"FC_VILLAGE_"..tostring(i)}
		insertEntry(p,t)
	end
	for k,v in pairs(FCconfig["profile"]["vanillaVillages"]) do
		local t = {}
		t.ShortName = k
		t.EventActionList={}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "EVENT_ACTION_"..op.."_TRADE_ROUTE"
		t.EventActionList[1].VillageListToAdd = {k}
		insertEntry(p,t)
	end
end

local function createTradeBonusButtons(p, list,estate)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardTradeBonus(v,60,{estate})
		}
		insertEntry(p,t)
	end
end

local function createNeedRateButtons(p, list, need)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardNeedRate(v,60, need)
		}
		insertEntry(p,t)
	end
end

local function createProductionButtons(p, list,job)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardProduction(v,60, job)
		}
		insertEntry(p,t)
	end
end

local function createYieldButtons(p, list,resource)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardCrop(v,60, {resource})
		}
		insertEntry(p,t)
	end
end

local function createMarketPriceButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardMarket(v,60)
		}
		insertEntry(p,t)
	end
end

local function createImmigrationRateButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardImmigrationRate(v,60)
		}
		insertEntry(p,t)
	end
end

local function createNeedFilledButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = v
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardNeedFilled(v,60)
		}
		insertEntry(p,t)
	end
end

local function createHappyButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardHappy(v,60)
		}
		insertEntry(p,t)
	end
end

local function createRecoveryButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardRecovery(v,60)
		}
		insertEntry(p,t)
	end
end

local function createTrainingButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardMilitary(v,60)
		}
		insertEntry(p,t)
	end
end

local function createLearningButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardJob(v,60)
		}
		insertEntry(p,t)
	end
end

local function createSplendorButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardSplendor(v,60)
		}
		insertEntry(p,t)
	end
end

local function createDesirabilityButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardDesirability(v,60)
		}
		insertEntry(p,t)
	end
end

local function createAllResourceButtons()
	local questRewardList = {}
	for _,v in ipairs(comList) do	--COMMODITY_RESOURCES
		table.insert(questRewardList,{
			Resource = v,
			Quantity = 10000	
		})
	end
	insertEntry({1,1,1,1,1},{	
		ShortName = "ALL_RESOURCES",
		EventActionList = {
			{
				DataType = "EVENT_ACTION_GIVE_REWARD",
				QuestRewardList = {
					QuestRewardResources(questRewardList)
				}
			}
		}
	})
	
	questRewardList = {}
	for _,v in ipairs(rawList) do	--CONSTRUCTION_RESOURCES
		table.insert(questRewardList,{
			Resource = v,
			Quantity = 5000	
		})
	end
	insertEntry({1,1,2,1,1},{	
		ShortName = "ALL_RESOURCES",
		EventActionList = {
			{
				DataType = "EVENT_ACTION_GIVE_REWARD",
				QuestRewardList = {
					QuestRewardResources(questRewardList)
				}
			}
		}
	})
	
	questRewardList = {}
	for _,v in ipairs(conList) do	--RAW_RESOURCES
		table.insert(questRewardList,{
			Resource = v,
			Quantity = 5000	
		})
	end
	insertEntry({1,1,3,1,1},{	
		ShortName = "ALL_RESOURCES",
		EventActionList = {
			{
				DataType = "EVENT_ACTION_GIVE_REWARD",
				QuestRewardList = {
					QuestRewardResources(questRewardList)
				}
			}
		}
	})
	questRewardList = nil
end

local function createPassiveInfluenceButtons(p, list, estate)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardPassiveInfluence(v,60,estate)
		}
		insertEntry(p,t)
	end
end

local function createMaintenanceButtons(p, list)
	for _,v in ipairs(list) do
		local t = {}
		t.ShortName = "FE_"..v.."_ACCEPT"
		t.EventActionList = {}
		t.EventActionList[1]={}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardMaintenance(v,60)
		}
		insertEntry(p,t)
	end
end

local function createImmigrationButton(p)
		local t = {}
		t.ShortName = "FE_IMMIGRATE_ACCEPT" 
		t.EventActionList = {}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardImmigration()
		}
		overrideEntry(p,t)
end

local function createTerritoryButton(p)
		local t = {}
		t.ShortName = "FE_TERRITORY_ACCEPT" 
		t.EventActionList = {}
		t.EventActionList[1] = {}
		t.EventActionList[1].DataType = "EVENT_ACTION_GIVE_REWARD"
		t.EventActionList[1].QuestRewardList = {
			QuestRewardTerritory()
		}
		overrideEntry(p,t)
end

local function createBackExitButtons(p,list)
	for i,v in ipairs(list) do
		local tempP = table.shallow_copy(p)
		tempP[tableSize(tempP)] = i
		table.insert(tempP,1)
		table.insert(tempP,1)
		insertEntry(tempP,backButton)
		insertEntry(tempP,exitButton)
	end
end

--create panels and tablestructure
choiceList = {}
createPanelButtons({1},mainPanelList)

createPanelButtons({1,1,1},resourcePanelList)

createPanelButtons({5,1,1},gameRulePanelList)
createPanelButtons({5,1,1,1,1},influenceList)
createPanelButtons({5,1,3,1,1}, jobList)
createPanelButtons({5,1,4,1,1}, resourcePanelList)
createPanelButtons({5,1,4,1,1,1,1},comList)
createPanelButtons({5,1,4,1,2,1,1},rawList)
createPanelButtons({5,1,4,1,3,1,1},conList)
createPanelButtons({5,1,6,1,1},needList)
createPanelButtons({5,1,11,1,1},influenceList)

createPanelButtons({6,1,1},tradePanelList)

--create non-panel buttons
createResourceButtons({1,1,1,1,1},comList)
createResourceButtons({1,1,2,1,1},rawList)
createResourceButtons({1,1,3,1,1},conList)

createAllResourceButtons()

createWeatherButtons({2,1,1},weatherList)

createInfluenceButtons({3,1,1},influenceList)

createBlueprintButtons({4,1,1}, blueprintlist)

createTradeBonusButtons({5,1,1,1,1,1,1}, percList, "LABOUR")
createTradeBonusButtons({5,1,1,1,2,1,1}, percList, "KINGDOM")
createTradeBonusButtons({5,1,1,1,3,1,1}, percList, "CLERGY")
createMarketPriceButtons({5,1,2,1,1},percList)
for k,v in ipairs(jobList) do
	createProductionButtons({5,1,3,1,k,1,1},percList,v)
end
for k,v in ipairs(comList) do
	createYieldButtons({5,1,4,1,1,1,k,1,1},percList,v)
end
for k,v in ipairs(rawList) do
	createYieldButtons({5,1,4,1,2,1,k,1,1},percList,v)
end
for k,v in ipairs(conList) do
	createYieldButtons({5,1,4,1,3,1,k,1,1},percList,v)
end
	createHappyButtons({5,1,5,1,1},percList)
for k,v in ipairs(needList) do
	createNeedRateButtons({5,1,6,1,k,1,1},percList,v)
end
--createNeedFilledButtons({5,1,7,1,1}, comList)
createImmigrationRateButtons({5,1,7,1,1},intList)
createRecoveryButtons({5,1,8,1,1},percList)
createTrainingButtons({5,1,9,1,1},percList)
createLearningButtons({5,1,10,1,1},percList)
for k,v in ipairs(influenceList) do
	createPassiveInfluenceButtons({5,1,11,1,k,1,1},percList,v)
end
createSplendorButtons({5,1,12,1,1},percList)
createMaintenanceButtons({5,1,13,1,1},percList)
--createDesirabilityButtons({6,1,15,1,1},percList)
---[[
createTradeRouteButtons({6,1,1,1,1},"ADD")
createTradeRouteButtons({6,1,2,1,1},"REMOVE")
--]]
createImmigrationButton({7})

createTerritoryButton({8})

--createMilitaryCampaignButtons({5,1,1}, campaignList)

--createUnlockBuildingButtons({6,1,1},unlockList)

--create back and exit buttons
createBackExitButtons({1},mainPanelList)
createBackExitButtons({1,1,1},resourcePanelList)
createBackExitButtons({5,1,1},gameRulePanelList)
createBackExitButtons({5,1,1,1,1},influenceList)
createBackExitButtons({5,1,3,1,1}, jobList)
createBackExitButtons({5,1,4,1,1}, resourcePanelList)
createBackExitButtons({5,1,4,1,1,1,1},comList)
createBackExitButtons({5,1,4,1,2,1,1},rawList)
createBackExitButtons({5,1,4,1,3,1,1},conList)
createBackExitButtons({5,1,6,1,1},needList)
createBackExitButtons({5,1,11,1,1},influenceList)
createBackExitButtons({6,1,1},tradePanelList)
table.insert(choiceList,exitButton)
	
FC:register({ DataType = "QUEST", Id = "INFINITE_RESOURCES_QUEST",
	Name = "INFINITE_RESOURCES_QUEST_NAME",
	Description = "INFINITE_RESOURCES_QUEST_DESC",
	QuestFunction = QuestFunctionDelivery({{Resource = "BERRIES", Quantity = 1}}),	
	QuestRewardList = {
		QuestRewardResources({{Resource = "BERRIES", Quantity = 1}}),
	},
	QuestListToUnlockAfter = {{QuestResource = "INFINITE_RESOURCES_QUEST", Delay = 0}},
	OnSuccessCallback = {

		DataType = "EVENT_CALLBACK_TRIGGER_EVENT", 
		Event = "INFINITE_RESOURCES_EVENT", 
		Delay = 0

	} 
})

FC:register({DataType = "EVENT", Id = "INFINITE_RESOURCES_EVENT",
	Delay = 0,
	ActionList = {
		{
			DataType = "ACTION_SHOW_NARRATIVE_PANEL",
			NarrativePanelData = {
				Title = "INFINITE_RESOURCES_EVENT_TITLE",
				Description = "INFINITE_RESOURCES_EVENT_DESC",
				PanelVisual = "ILLUSTRATION_ESTATE_CHURCH",
			},
			ChoiceList = choiceList
		}
	}
})